<template>
    <div 
        v-if="!error && is_control" 
        class="pos collapse show" 
        id="collapseExample" 
        ref="collapse"
    >
        <div class="cont-fon">
            <div class="fon"></div>
        </div>
        <div style="margin-bottom:8px;">
            <div class="progress" :style="`height: 5px; width: ${control.width}px`">
                
                <div class="progress-bar" role="progressbar" :style="`width: ${select_video.percent}%;`" ref="progressBar"></div>
            </div>
            <div class="slidecontainer" :style="`width: ${control.width}px`">
                <input 
                    type="range" 
                    min="0" 
                    :max="select_video.time" 
                    :value="select_video.current_time" 
                    class="slider" 
                    ref="myRange"
                    @input="$emit('changeTime', $event.target.value);"
                    style="background:red;"
                >
            </div>
        </div>
        <div class="btn-group" style="width:100%">
            <div
            class="align-middle"
            @mouseout="onMouseOut"
            @mouseover="onMouseOver">
                
                <div ref="volum" class="drop-up justify-content-center">
                    <input 
                        type="range" 
                        min="0" 
                        max="1" 
                        :value="control.volum" 
                        step="0.1" 
                        style="transform: rotate(-90deg);width:50px;"
                        @input="$emit('onChangeSound', $event.target.value);"
                    >
                </div>
                <div
                    class="div_ico_btn"
                    @click="$emit('onSound')"
                >
                    <svg
                        xmlns="http://www.w3.org/2000/svg" 
                        :width="width/0.9" 
                        :height="height/0.9"
                        style="vertical-align:unset;" 
                        viewBox="0 0 44 44"
                    >
                        <g>
                            <path fill="innerhan" d="M2.878,14.623c-1.15,0-2.766,0.73-2.774,3.03c0,0.757-0.009,5.808,0,8.153
                                c0.009,2.344,1.35,3.101,2.774,3.101c1.424,0,7.744,0,7.744,0l5.839,6.493c0,0,2.045,0,3.213,0c1.168,0,1.461-0.414,1.461-2.019
                                c0-1.606,0.019-21.914,0-23.231c-0.019-1.317-0.43-1.948-1.389-1.948c-0.958,0-3.149,0-3.149,0l-5.976,6.423
                                C10.622,14.625,3.645,14.649,2.878,14.623z"/>
                            <path v-if="control.volum<=0" fill="innerhan" d="M31.39,22.51l3.265-3.266c0.573-0.572,0.573-1.499,0-2.071c-0.57-0.571-1.497-0.571-2.069,0l-3.266,3.266
                                l-3.266-3.266c-0.572-0.571-1.499-0.571-2.071,0c-0.571,0.572-0.571,1.499,0,2.07l3.267,3.267l-3.267,3.266
                                c-0.571,0.57-0.571,1.498,0,2.071c0.572,0.57,1.499,0.57,2.071,0l3.266-3.267l3.266,3.267c0.572,0.57,1.499,0.57,2.069,0
                                c0.573-0.573,0.573-1.501,0-2.071L31.39,22.51z"/>
                            <path v-if="control.volum>0" fill="innerhan" d="M23.431,15.917c-0.193,0-0.375,0.041-0.562,0.059v2.582c1.89,0.083,3.399,1.678,3.399,3.649
                                c0,1.972-1.51,3.567-3.399,3.65v2.582c0.187,0.019,0.368,0.059,0.562,0.059c3.365,0,6.093-2.816,6.093-6.291
                                C29.523,18.733,26.796,15.917,23.431,15.917z"/>
                            <path v-if="control.volum>0.5" fill="innerhan" d="M26.813,9.051v3.351c3.067,1.351,5.275,5.044,5.275,9.399c0,4.356-2.208,8.049-5.275,9.398v2.954
                                c5.446-0.019,9.858-5.631,9.858-12.551S32.259,9.07,26.813,9.051z"/>
                            <path v-if="control.volum>=0.8" fill="innerhan" d="M30.428,3.167v4.589c5.041,1.149,8.879,6.926,8.879,13.9c0,6.973-3.838,12.752-8.879,13.9v4.589
                                c7.528-0.7,13.473-8.699,13.473-18.489S37.956,3.867,30.428,3.167z"/>
                            
                        </g>
                    </svg>
                    <!-- <i v-if="control.volum<=0" class="fas fa-volume-mute"></i>
                    <i v-else-if="control.volum>=1" class="fas fa-volume-up"></i>
                    <i v-else-if="control.volum>0&&control.volum<1" class="fas fa-volume-down"></i> -->
                </div>
                <!-- <button
                    v-if="control.volum<=0" 
                    class="btn btn-primary btn-sm" 
                    @click="$emit('onSound')"
                >SoundOn</button>
                <button 
                    v-else
                    class="btn btn-primary btn-sm" 
                    @click="$emit('onSound')"
                >SoundOff</button> -->
            </div>

            <div
                class="div_ico_btn"
                @click="$emit('onPlay')"
            >
                <svg 
                    
                    xmlns="http://www.w3.org/2000/svg" 
                    :width="width" 
                    :height="height"
                    style="vertical-align:unset;" 
                    viewBox="0 0 40 40"
                >
                    <path v-if="!control.play" fill="innerhan" d="M37.65,17.411L1.561,0.042v39.917l36.381-18.455C39.641,20.595,39.827,18.247,37.65,17.411z"/>
                    <g v-else >
                        <path fill="innerhan" d="M15.148,32.555c0,4.044-2.808,7.323-6.271,7.323l0,0c-3.464,0-6.271-3.279-6.271-7.323V7.446
                            c0-4.044,2.808-7.322,6.271-7.322l0,0c3.463,0,6.271,3.278,6.271,7.322V32.555z"/>
                        <path fill="innerhan" d="M37.395,32.555c0,4.044-2.808,7.323-6.271,7.323l0,0c-3.464,0-6.271-3.279-6.271-7.323V7.446
                            c0-4.044,2.808-7.322,6.271-7.322l0,0c3.464,0,6.271,3.278,6.271,7.322V32.555z"/>
                    </g>
                </svg>
                <!-- <i v-if="!control.play" class="fas fa-play"></i> -->
                <!-- <i v-else class="fas fa-pause"></i> -->
            </div>
            <!-- <button v-if="control.play" class="btn btn-primary btn-sm" @click="$emit('onPlay')">Stop</button>
            <button v-else class="btn btn-primary btn-sm" @click="$emit('onPlay')">Play</button> -->

            <h5 v-if="control.width>280" style="margin-left:20px;margin-right:20px;">
                <span class="badge badge-secondary" :style="`color:${color}`">
                    {{`${timeCounter(select_video.current_time,select_video.time)}`}}
                </span>
            </h5>

            <div class="d-flex justify-content-end" style="width:100%">
                <div
                    class="div_ico_btn"
                    @click="$emit('toggleSideList')"
                >
                    <svg 
                        
                        xmlns="http://www.w3.org/2000/svg" 
                        :width="width" 
                        :height="height"
                        style="vertical-align:unset;" 
                        viewBox="0 0 40 40"
                    >
                        <path v-if="control.list_orientation==='row'" fill="innerhan" d="M35.479,2.427H4.521C2.025,2.427,0,4.422,0,6.882v26.236c0,2.461,2.025,4.455,4.521,4.455h30.958
                            c2.497,0,4.521-1.994,4.521-4.455V6.882C40,4.422,37.977,2.427,35.479,2.427z M3.029,31.132V8.868c0-2.088,1.718-3.78,3.836-3.78H20
                            v29.825H6.865C4.747,34.913,3.029,33.22,3.029,31.132z"/>

                        <path v-else fill="innerhan" d="M35.479,2.093H4.521C2.024,2.093,0,4.125,0,6.633v26.734c0,2.508,2.024,4.54,4.521,4.54h30.958
                            c2.497,0,4.521-2.032,4.521-4.54V6.633C40,4.125,37.976,2.093,35.479,2.093z M6.864,4.804h26.271c2.119,0,3.836,1.725,3.836,3.852
                            v10.737H3.027V8.656C3.027,6.529,4.746,4.804,6.864,4.804z"/>
                    </svg>
                </div>
                <div class="btn-group dropup">
                    <div 
                        class="div_ico_btn"
                        @click="speed_list=!speed_list"
                    >
                        <svg 
                            xmlns="http://www.w3.org/2000/svg" 
                            :width="width/0.88" 
                            :height="height/0.88"
                            style="vertical-align:unset;" 
                            viewBox="0 0 40 40"
                        >
                            <path fill="innerhan" d="M20,5.164c-11.045,0-20,8.496-20,18.977c0,3.678,1.12,7.1,3.03,10.008h33.938
                                C38.88,31.24,40,27.818,40,24.141C40,13.66,31.045,5.164,20,5.164z M20,7.949c1.093,0,1.98,0.887,1.98,1.982
                                c0,1.095-0.888,1.983-1.98,1.983c-1.094,0-1.981-0.888-1.981-1.983C18.019,8.836,18.906,7.949,20,7.949z M4.78,27.917
                                c-1.094,0-1.98-0.888-1.98-1.982c0-1.094,0.887-1.982,1.98-1.982c1.094,0,1.981,0.889,1.981,1.982
                                C6.761,27.029,5.874,27.917,4.78,27.917z M8.742,16.966c-1.094,0-1.981-0.888-1.981-1.983C6.761,13.887,7.648,13,8.742,13
                                s1.981,0.887,1.981,1.983C10.724,16.078,9.836,16.966,8.742,16.966z M27.546,12.984l-5.87,13.717
                                c0.93,0.537,1.554,1.501,1.554,2.609c0,0.593-0.18,1.147-0.488,1.616h-5.482c-0.309-0.469-0.489-1.023-0.489-1.616
                                c0-1.493,1.125-2.732,2.614-3.007l6.08-14.21c0.245-0.576,0.912-0.842,1.485-0.596C27.525,11.744,27.79,12.41,27.546,12.984z
                                M30.188,14.983c0-1.096,0.888-1.983,1.98-1.983c1.095,0,1.982,0.887,1.982,1.983c0,1.095-0.888,1.983-1.982,1.983
                                C31.076,16.966,30.188,16.078,30.188,14.983z M35,27.917c-1.094,0-1.98-0.888-1.98-1.982c0-1.094,0.887-1.982,1.98-1.982
                                s1.98,0.889,1.98,1.982C36.98,27.029,36.094,27.917,35,27.917z"/>
                        </svg>
                        <!-- <i class="fas fa-tachometer-alt"></i> -->
                        x{{select_video.playback_rate}}
                    </div>

                <div v-if="speed_list" class="dropup-menu">
                    <div class="card bg-secondary"
                        
                    >
                        <button
                            v-for="(speed,i) in control.speeds"
                            :key="i"
                            :class="`btn ${isSpeedSelect(speed)}`"
                            :style="`color:${color};`"
                            type="button"
                            @click="onChangeSpeed(speed)"
                        >x{{speed}}</button>
                    </div>
                </div>
                </div>

                <div 
                    class="div_ico_btn"
                    @click="$emit('onToggleFullscreen')"
                >
                    <svg 
                        xmlns="http://www.w3.org/2000/svg" 
                        :width="width/0.88" 
                        :height="height/0.88"
                        style="vertical-align:unset;" 
                        viewBox="0 0 40 40"
                    >
                        <g v-if="control.full_screen">
                            <polygon fill="innerhan" points="39.999,22.713 22.002,22.713 22.002,23.869 22.002,27.107 22.002,37.287 26.481,37.287 
                                26.481,27.107 39.999,27.107 "/>
                            <polygon fill="innerhan" points="39.998,17.287 22.002,17.287 22.002,16.131 22.002,12.892 22.002,2.713 26.48,2.713 26.48,12.892 
                                39.998,12.892 "/>
                            <polygon fill="innerhan" points="0.002,17.287 17.998,17.287 17.998,16.131 17.998,12.892 17.998,2.713 13.519,2.713 13.519,12.892 
                                0.002,12.892 "/>
                            <polygon fill="innerhan" points="0,22.712 17.996,22.712 17.996,23.869 17.996,27.108 17.996,37.287 13.517,37.287 13.517,27.108 
                                0,27.108 "/>
                        </g>
                        <g v-else>
                            <polygon fill="innerhan" points="17.996,3.768 0,3.768 0,4.924 0,8.163 0,18.342 4.479,18.342 4.479,8.163 17.996,8.163 "/>
                            <polygon fill="innerhan" points="17.996,36.232 0,36.232 0,35.076 0,31.837 0,21.658 4.479,21.658 4.479,31.837 17.996,31.837 "/>
                            <polygon fill="innerhan" points="22.004,36.232 40,36.232 40,35.076 40,31.837 40,21.658 35.521,21.658 35.521,31.837 22.004,31.837 
                                "/>
                            <polygon fill="innerhan" points="22.004,3.768 40,3.768 40,4.924 40,8.163 40,18.342 35.521,18.342 35.521,8.163 22.004,8.163 "/>
                        </g>
                    </svg>
                    <!-- <i v-if="control.full_screen" class="fas fa-compress"></i>
                    <i v-else class="fas fa-expand"></i> -->
                </div>

                <!-- <button type="button" class="btn btn-primary" @click="$emit('onToggleFullscreen')">
                    
                    {{full_screen_label}}
                </button> -->
            </div>

            
        </div>
        
        
    </div>
    
</template>

<script>
//import '@fortawesome/fontawesome-free/css/all.css';
import formData from '../services/formData';
import CalcSizer from '../services/calcSizer';
//
//aria-valuenow="25" aria-valuemin="0" aria-valuemax="100"
export default {
    name: 'ControlPanel',
    components: {
        
    },
    props:{
        control:Object,
        select_video:Object,
        error:Boolean,
        is_control:Boolean,
        color:String
    },
    mounted(){
        this.font_style = document.createElement('style');
        this.font_style.type = 'text/css';

        this.style = document.createElement('style');
        this.style.type = 'text/css';
        document.head.appendChild(this.style);
        document.head.appendChild(this.font_style);
        this.setColor();
        this.setFontSize();
    },
    data: () => ({
        width:20,
        height:20,
        speed_list:false,
        full_screen_label:'fullSreen',
        el_style:null,
        d_font_size:22
    }),
    watch:{
        'color':'setColor',
        'is_control':'isView',
        'control.full_screen':'fullScreenLabel',
        'control.width':'setFontSize'
    },
    methods:{
        setFontSize(){
            const size = CalcSizer.calcSizeico(this);
            this.width = size.width;
            this.height = size.height;
            // let r = 800 - this.control.width;
            // let size = 0;
            // let t_size = 22;
            // if(r>0){
                
            //     size = this.d_font_size - r*0.01+'px';
            //     this.width = 22 - r*0.01;
            //     this.height = 22 - r*0.01;
            // }else{
            //     r = Math.abs(r);
            //     size = this.d_font_size + r*0.01+'px';
            //     this.width = 22 + r*0.01;
            //     this.height = 22 + r*0.01;
            // }
            this.font_style.innerHTML = `
                .div_ico_btn {font-size: ${size.size};
            `;
            
        },
        setColor(){
            this.style.innerHTML = `.slider::-webkit-slider-thumb { background: ${this.color}; }
                .slider::-moz-range-thumb { background: ${this.color}; }
                .div_ico_btn {fill: ${this.color};color:${this.color};}
            `;
        },
        fullScreenLabel(){
            if(this.control.full_screen){
                this.full_screen_label = 'windowSreen';
            }else{
                this.full_screen_label = 'fullSreen';
            }
        },
        isSpeedSelect(speed){
            if(this.select_video.playback_rate==speed){
                return 'btn-primary';
            }
            return;
        },
        onChangeSpeed(speed){
            this.speed_list = false;
            this.$emit('onChangeSpeed',speed);
        },
        onMouseOver(){
            this.$refs.volum.style.display = 'flex';
        },
        onMouseOut(){
            this.$refs.volum.style.display = 'none';
        },
        timeCounter(current_time,time){
            return `${formData.getPreatyTime(Math.floor(current_time))}
                    /${formData.getPreatyTime(time)}`;
        },
        isView(){
            if(this.is_control===false){
                this.speed_list = false;
            }
        }
    }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
    .cont-fon{
        bottom:0;
        position: absolute;
        width: 100%;
        height: 142%;
    }
    .fon{
        /* margin-top:50%; */
        width: 100%;
        height: 100%;
        /* background: #4CAF50; */
        background: linear-gradient(to top, #000000, #00000080,#ffffff00);
    }
    .dropup-menu{
        position: absolute;
        top: auto;
        max-width:200px;
        min-width: 88px;
        max-height:120px;
        overflow-y: auto;
        bottom: 100%;
        margin-top: 0;
        margin-bottom: .125rem;
        z-index: 102;
    }

    .pos{
        bottom: 0;
        /* height: 12%; */
        max-height: 80px;
        z-index: 102;
        position: absolute;
    }

    .slidecontainer {
        position: absolute;
        top:-15px;
    }

    .slider {
        -webkit-appearance: none;
        width: 100%;
        height: 0px;
        /* border-radius: 5px; */
        outline: none;
        opacity: 1;
        /* -webkit-transition: .2s;
        transition: opacity .2s; */
    }

    .slider:hover {
        opacity: 1;
    }

    .slider::-webkit-slider-thumb {
        -webkit-appearance: none;
        appearance: none;
        width: 12px;
        height: 12px;
        border-radius: 50%;
        
        cursor: pointer;
    }

    .slider::-moz-range-thumb {
        width: 12px;
        height: 12px;
        border-radius: 50%;
        /* background: rgb(252, 231, 41); */
        cursor: pointer;
    }

    .drop-up{
        width: 62px;
        height: 80px;
        top:40px;
        background-color: black;
        opacity: 0.5;
        position: absolute;
        display: none;
        transform: translate3d(0px, -120px, 0px);
    }
    .div_ico_btn{
        margin-left:12px;
        margin-right:12px;
        cursor:pointer;
        /* font-size: 24px; */
        /* margin-left:-50%;
        margin-top:-50%; */
        /* color: rgb(252, 231, 41); */
    }
</style>
